GitLab steht aufgrund wichtiger Wartungsarbeiten am Montag, den 8. März, zwischen 17:00 und 19:00 Uhr nicht zur Verfügung.

Commit 01d190a8 authored by Timothy Andrew's avatar Timothy Andrew

Have the `branches` API work with the new protected branches data model.

1. The new data model moves from `developers_can_{push,merge}` to
   `allowed_to_{push,merge}`.

2. The API interface has not been changed. It still accepts
   `developers_can_push` and `developers_can_merge` as options. These
   attributes are inferred from the new data model.

3. Modify the protected branch create/update services to translate from
   the API interface to our current data model.
parent 88fd401d
module ProtectedBranches
class BaseService < ::BaseService
include API::Helpers
def initialize(project, current_user, params = {})
super(project, current_user, params)
@allowed_to_push = params[:allowed_to_push]
@allowed_to_merge = params[:allowed_to_merge]
end
def set_access_levels!
translate_api_params!
set_merge_access_levels!
set_push_access_levels!
end
......@@ -8,7 +17,7 @@ def set_access_levels!
protected
def set_merge_access_levels!
case params[:allowed_to_merge]
case @allowed_to_merge
when 'masters'
@protected_branch.merge_access_level.masters!
when 'developers'
......@@ -17,7 +26,7 @@ def set_merge_access_levels!
end
def set_push_access_levels!
case params[:allowed_to_push]
case @allowed_to_push
when 'masters'
@protected_branch.push_access_level.masters!
when 'developers'
......@@ -26,5 +35,26 @@ def set_push_access_levels!
@protected_branch.push_access_level.no_one!
end
end
# The `branches` API still uses `developers_can_push` and `developers_can_merge`,
# which need to be translated to `allowed_to_push` and `allowed_to_merge`,
# respectively.
def translate_api_params!
@allowed_to_push ||=
case to_boolean(params[:developers_can_push])
when true
'developers'
when false
'masters'
end
@allowed_to_merge ||=
case to_boolean(params[:developers_can_merge])
when true
'developers'
when false
'masters'
end
end
end
end
......@@ -35,6 +35,10 @@ class Branches < Grape::API
# Protect a single branch
#
# Note: The internal data model moved from `developers_can_{merge,push}` to `allowed_to_{merge,push}`
# in `gitlab-org/gitlab-ce!5081`. The API interface has not been changed (to maintain compatibility),
# but it works with the changed data model to infer `developers_can_merge` and `developers_can_push`.
#
# Parameters:
# id (required) - The ID of a project
# branch (required) - The name of the branch
......@@ -49,18 +53,19 @@ class Branches < Grape::API
@branch = user_project.repository.find_branch(params[:branch])
not_found!('Branch') unless @branch
protected_branch = user_project.protected_branches.find_by(name: @branch.name)
developers_can_push = to_boolean(params[:developers_can_push])
developers_can_merge = to_boolean(params[:developers_can_merge])
if protected_branch
protected_branch.developers_can_push = developers_can_push unless developers_can_push.nil?
protected_branch.developers_can_merge = developers_can_merge unless developers_can_merge.nil?
protected_branch.save
else
user_project.protected_branches.create(name: @branch.name,
developers_can_push: developers_can_push || false,
developers_can_merge: developers_can_merge || false)
end
protected_branch_params = {
name: @branch.name,
developers_can_push: params[:developers_can_push],
developers_can_merge: params[:developers_can_merge]
}
service = if protected_branch
ProtectedBranches::UpdateService.new(user_project, current_user, protected_branch.id, protected_branch_params)
else
ProtectedBranches::CreateService.new(user_project, current_user, protected_branch_params)
end
service.execute
present @branch, with: Entities::RepoBranch, project: user_project
end
......
......@@ -126,11 +126,13 @@ class RepoBranch < Grape::Entity
end
expose :developers_can_push do |repo_branch, options|
options[:project].developers_can_push_to_protected_branch? repo_branch.name
project = options[:project]
project.protected_branches.matching(repo_branch.name).any? { |protected_branch| protected_branch.push_access_level.developers? }
end
expose :developers_can_merge do |repo_branch, options|
options[:project].developers_can_merge_to_protected_branch? repo_branch.name
project = options[:project]
project.protected_branches.matching(repo_branch.name).any? { |protected_branch| protected_branch.merge_access_level.developers? }
end
end
......
......@@ -112,7 +112,7 @@
before do
project.repository.add_branch(user, protected_branch, 'master')
create(:protected_branch, project: project, name: protected_branch, developers_can_push: true, developers_can_merge: true)
create(:protected_branch, :developers_can_push, :developers_can_merge, project: project, name: protected_branch)
end
it 'updates that a developer can push' do
......
Markdown is supported
0% or .
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment